/*
Programm: Aufg.7
Zweck:    Erzeugung magischer Quadrate ungerader Ordnung bis Ordnung 9 
Aufgabe:  Entspricht der Aufgabe 7 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 2" bei Prof. Hoffmann.
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2002-09-05
*/

#include <iostream>
using namespace std;

void magiquad(int (&a)[9][9], int n) {
  //PRE: n<=9, n ungerade
  
  //Matrix initialisieren: Inhalt 0 bedeutet noch freies Feld
  for (int i=0; i<n; ++i)
    for (int j=0; j<n; ++j)
      a[i][j]=0;
	      
  int  i=0, j=n/2; //Anfangsposition ist a[i][j]
  int i_alt, j_alt;  //Backup der Position, an der zuletzt eingefuegt wurde
  
  for (int zahl=1; zahl<=n*n; ++zahl) {
    //Position besetzen:
    a[i][j]=zahl;
    i_alt=i; 
    j_alt=j;
    //Bestimme Position fuer naechstes Element:
    if (i-1<0) { // oberer Rand wird ueberschritten
      if (j+1>=n) // ... und rechter Rand wird ueberschritten
	++i;
      else {      // ... und rechter Rand wird nicht ueberschritten
	i=n-1;
	++j;
      }
    }
    else        // oberer Rand wird nicht uberschritten
      if (j+1>=n) { // ... und rechter Rand wird ueberschritten
	--i;
	j=0;
      }
      else {        // ... und rechter Rand wird nicht ueberschritten
	--i;
	++j;
      }
    if (a[i][j]!=0) { // Feld bereits besetzt
      i= ++i_alt;
      j=j_alt;
    }
      
  }
  //POST: a enthaelt ein magisches Quadrat der Ordnung n
}

//n*n-Matrix a ausdrucken
void showmatrix(int a[][9], const int &n) {
  for (int i=0; i<n; ++i) {
    for (int j=0; j<n; ++j) {
      cout.width(3); //groesste Zahl ist 9*9=81, es bleibt also stets ein Leerzeichen
      cout << a[i][j];
    }
    cout << endl;
  }
}

int main() {
  int a[9][9];
  int n;
  cout << "Erzeuge magisches Quadrat der Ordnung 1,3,5,7 oder 9" << endl << "Gewnschte Ordnung: ";
  cin >> n;
  if (n<=9 && n%2==1) {
    magiquad(a,n);
    showmatrix(a,n);
  }
  else
    cout << "Nur die Ordnungen 1,3,5,7 oder 9 sind zulssig" << endl;
}
