/*
Programm: Aufg.12
Zweck:    Splitting von C++-Strings an Trennzeichen 
Aufgabe:  Entspricht der Aufgabe 11 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 2" bei Prof. Hoffmann.
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2002-09-07
*/

#include <iostream>
#include <string>
using namespace std;

/* Splittet input an dc in Teilstrings auf. Die ersten 50 Teilstrings werden 
   in item[0] .. item[49] abgelegt, der Rest (nicht gesplittet) in item[50]
*/
int items(string input, char dc, string item[]) {
  string trenner(&dc); //dc als einelementiges Char-Array betrachten
  string::size_type wAnf, wEnde; // Wortanfang und Wortende

  int i = 0;
  wAnf = input.find_first_not_of (trenner);
  
  while (wAnf != string::npos && i<50) {
    //INV: item[i] ist erster freier Platz
    //INV: i ist Anzahl der Teilstrings in item[]
    wEnde = input.find_first_of (trenner, wAnf); // Suche ab einer Position
    if (wEnde != string::npos) 
      item[i] = input.substr (wAnf, wEnde - wAnf); 
    else 
      item[i] = input.substr (wAnf, input.length() - wAnf); 
    wAnf = input.find_first_not_of (trenner, wEnde); 
    ++i;
  }
  if (wAnf != string::npos) { //mehr als 50 items vorhanden! 
    item[50] = input.substr(wAnf, input.length() - wAnf);
    i=51; //item[50] belegt: mehr als 50 items
  }
  return i; //i ist Anzahl der Teilstrings in item[]
}

int main() { //Testbett fuer items
  string teststring;
  string item[51];
  int itemCount, i;
  char separator;

  cout << "Gewnschtes Trennzeichen: ";
  cin >> separator;
  cout << "Bitte Teststring eingeben: ";
  cin >> teststring;

  itemCount = items(teststring, separator, item);
  cout << "Enthaltene Teilstrings:" << endl;
  for (i=0; i<50 && i<itemCount; ++i) { //i<50: Reststring nicht 
                                        //ausgeben, wenn vorhanden
    cout << item[i] << endl;
  }
  cout << "Anzahl der Teilstrings: " << (i<=50?i:50) << endl;
  if (itemCount == 51) { //Reststring vorhanden
    cout << endl << "Reststring:" << endl << item[50] << endl;
  }
}
