/*
Programm: Aufg.27
Zweck:    Ergaenzung des Programms der Aufgabenstellung um geeignete Ausgaben
Aufgabe:  Entspricht der Aufgabe 27 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 2" bei Prof. Hoffmann.
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2002-09-23
*/

#include <iostream>
#include <string>
using namespace std;

class Datumrechner {
  public:
    Datumrechner();  
    bool setzebasisdatum(string datum);
    bool setzeaktuellesdatum(string datum);
    string zeigebasisdatum();
    string zeigeaktuellesdatum();
    int datumdiff();
  private:
    struct Datum {
      Datum();
      Datum(int init_tag, int init_monat, int init_jahr);
      int tag;
      int monat;
      int jahr;
    };
    Datum basisDatum, aktDatum;
    bool setzeDatum(Datum &datum, string datumstring);
    string zeigeDatum(Datum datum);
};

Datumrechner::Datum::Datum() {
  tag=1;
  monat=1;
  jahr=2000;
}

Datumrechner::Datum::Datum(int init_tag, int init_monat, int init_jahr) {
  tag = init_tag;
  monat = init_monat;
  jahr = init_jahr;
}

Datumrechner::Datumrechner(): basisDatum(), aktDatum()  {
}

string Datumrechner::zeigeDatum(Datum datum) {
  return ; // ...
}

string Datumrechner::zeigebasisdatum() {
  return zeigeDatum(basisDatum);
}

string Datumrechner::zeigeaktuellesdatum() {
  return zeigeDatum(aktDatum);
}

bool Datumrechner::setzebasisdatum(string datum) {
  return setzeDatum(basisDatum, datum);
}

bool Datumrechner::setzeaktuellesdatum(string datum) {
  return setzeDatum(basisDatum, datum);
}

bool Datumrechner::setzeDatum(Datum &datum, string datumstring) {
  string::size_type pos=0;
  Datum tmpDatum;
  bool stringOK = true;
  int ziffern;
  char ziffer;
  
  while (pos != string::npos) {
    ziffern = 0;
    while (datumstring.at(pos) != '.' && pos != string::npos) {
      //Tag ermitteln
      ziffer = datumstring.at(pos);
      if (ziffer<30 || ziffer>39) {stringOK = false; break;}
      else tmpDatum.tag = (tmpDatum.tag*10) + ziffer-30;
      ziffern++;
      pos++;
    }
    if (datumstring.at(pos) != '.' || ziffern==0 || ziffern>2) stringOK = false; 
    if (!stringOK) break;

    pos++;
    
    ziffern=0;
    while (datumstring.at(pos) != '.' && pos != string::npos){
      //Monat ermitteln
      ziffer = datumstring.at(pos);
      if (ziffer<30 || ziffer>39) {stringOK = false; break;}
      else tmpDatum.monat = (tmpDatum.monat*10) + ziffer-30;
      ziffern++;
      pos++;
    }
    if (datumstring.at(pos) != '.' || ziffern==0 || ziffern>2) stringOK = false;
    if (!stringOK) break;
    
    pos++;
    
    ziffern = 0;
    while (pos != string::npos) {
      //Jahr ermitteln
      ziffer = datumstring.at(pos);
      if (ziffer<30 || ziffer>39) {stringOK = false; break;}
      else tmpDatum.jahr = (tmpDatum.jahr*10) + ziffer-30;
    }
    if (ziffern!=4) stringOK = false;
  }
  
  if (stringOK) {
    datum= tmpDatum;
    return true;
  }
  else return false; 
}

int main () {
}
